#include<bits/stdc++.h>

#define int long long
#define pb push_back
#define ld long double

using namespace std;

mt19937 rnd(239);
const int p1 = 241, MOD1 = 1178094557, k1 = 113, MOD2 = 1783617887, p2 = 257, k2 = 131, N = 1e5 + 10;
int kek;
int po1[N], po2[N];

int mul1(int a, int b) {
    return (a * b) % MOD1;
}

int mul2(int a, int b) {
    return (a * b) % MOD2;
}

int add1(int a, int b) {
    return a + b >= MOD1 ? a + b - MOD1 : a + b;
}

int add2(int a, int b) {
    return a + b >= MOD2 ? a + b - MOD2 : a + b;
}

int sub1(int a, int b) {
    return a - b < 0 ? a - b + MOD1 : a - b;
}

int sub2(int a, int b) {
    return a - b < 0 ? a - b + MOD2 : a - b;
}

int binpow1(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        int g = binpow1(a, n / 2);
        return mul1(g, g);
    } else {
        return mul1(binpow1(a, n - 1), a);
    }
}

int binpow2(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        int g = binpow2(a, n / 2);
        return mul2(g, g);
    } else {
        return mul2(binpow2(a, n - 1), a);
    }
}

int inv1(int a) {
    return binpow1(a, MOD1 - 2);
}

int inv2(int a) {
    return binpow2(a, MOD2 - 2);
}

vector<int> sum(vector<int> a, vector<int> b) {
    vector<int> c(a.size());
    for (int i = 0; i < a.size(); i++) {
        c[i] = a[i] + b[i];
    }
    return c;
}

bool is_palindrom(vector<int> a) {
    int n = a.size();
    for (int i = 0; i < n; i++) {
        if (a[i] != a[n - i - 1]) {
            return 0;
        }
    }
    return 1;
}

int solve(int n, int m, vector<int> a, vector<int> b) {
    for (int k = min(n, m); k >= 1; k--) {
        vector<vector<int>> A, B;
        for (int i = 0; i + k <= n; i++) {
            A.pb(vector<int>{a.begin() + i, a.begin() + i + k});
        }
        for (int i = 0; i + k <= m; i++) {
            B.pb(vector<int>{b.begin() + i, b.begin() + i + k});
        }
        for (auto to1 : A) {
            for (auto to2 : B) {
                if (is_palindrom(sum(to1, to2))) {
                    return k;
                }
            }
        }
    }
    return -1;
}

unordered_set<int> sta, stb;

void add(int n, vector<int> a, bool flag, int len) {
    vector<int> pr1(n), sf1(n), pr2(n), sf2(n);
    if (flag) reverse(a.begin(), a.end());
    int now1 = 1, now2 = 1;
    for (int i = 0; i < n; i++) {
        if (i > 0) {
            pr1[i] = pr1[i - 1];
            pr2[i] = pr2[i - 1];
        }
        pr1[i] = add1(pr1[i], mul1(now1, a[i]));
        pr2[i] = add2(pr2[i], mul2(now2, a[i]));
        now1 = mul1(now1, p1);
        now2 = mul2(now2, p2);
    }
    now1 = 1, now2 = 1;
    for (int i = n - 1; i >= 0; i--) {
        if (i + 1 < n) {
            sf1[i] = sf1[i + 1];
            sf2[i] = sf2[i + 1];
        }
        sf1[i] = add1(sf1[i], mul1(now1, a[i] + k1));
        sf2[i] = add2(sf2[i], mul2(now2, a[i] + k1));
        now1 = mul1(now1, p1);
        now2 = mul2(now2, p2);
    }
    for (int i = 0; i < n; i++) {
        int res1 = -1, res2 = -1;
        if (len % 2 == 1) {
            if (i + len / 2 < n && i - len / 2 >= 0) {
                //int real_res = 0, now = p;
                res1 = 0;
                res1 = add1(res1, mul1(sub1(sf1[i - len / 2], sf1[i]), po1[n - i - 1]));
                res1 = sub1(res1, mul1(sub1(pr1[i + len / 2], pr1[i]), po1[i]));
                res2 = 0;
                res2 = add2(res2, mul2(sub2(sf2[i - len / 2], sf2[i]), po2[n - i - 1]));
                res2 = sub2(res2, mul2(sub2(pr2[i + len / 2], pr2[i]), po2[i]));
            }
        } else {
            if (i + len / 2 < n && i - len / 2 + 1 >= 0) {
                res1 = 0;
                res1 = add1(res1, mul1(sub1(sf1[i - len / 2 + 1], sf1[i + 1]), po1[n - i - 2]));
                res1 = sub1(res1, mul1(sub1(pr1[i + len / 2], pr1[i]), po1[i]));
                res2 = 0;
                res2 = add2(res2, mul2(sub2(sf2[i - len / 2 + 1], sf2[i + 1]), po2[n - i - 2]));
                res2 = sub2(res2, mul2(sub2(pr2[i + len / 2], pr2[i]), po2[i]));
            }
        }
        if (res1 != -1) {
            if (flag) {
                sta.insert(res1 * MOD2 + res2);
            } else {
                stb.insert(res1 * MOD2 + res2);
            }
        }
    }
}

int smart_solve(int n, int m, vector<int> a, vector<int> b) {
    int l = 0, r = min(n, m) + 1;
    while (r - l > 1) {
        int mid = (r + l) / 2;
        if (2 * mid + 1 > min(n, m)) {
            r = mid;
            continue;
        }
        sta.clear();
        stb.clear();
        add(n, a, 1, 2 * mid + 1);
        add(m, b, 0, 2 * mid + 1);
        bool ok = 0;
        for (auto to : sta) {
            if (stb.find(to) != stb.end()) {
                ok = 1;
            }
        }
        if (ok) {
            l = mid;
        } else {
            r = mid;
        }
    }
    int mx = 2 * l + 1;
    l = 0, r = min(n, m) + 1;
    while (r - l > 1) {
        int mid = (r + l) / 2;
        if (2 * mid > min(n, m)) {
            r = mid;
            continue;
        }
        sta.clear();
        stb.clear();
        add(n, a, 1, 2 * mid);
        add(m, b, 0, 2 * mid);
        bool ok = 0;
        for (auto to : sta) {
            if (stb.find(to) != stb.end()) {
                ok = 1;
            }
        }
        if (ok) {
            l = mid;
        } else {
            r = mid;
        }
    }
    mx = max(mx, 2 * l);
    return mx;
}

bool is_prime(int n) {
    for (int i = 2; i * i <= n; i++) {
        if (n % i == 0) {
            return 0;
        }
    }
    return 1;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int now = 1;
    for (int i = 0; i < N; i++) {
        po1[i] = inv1(now);
        now = mul1(now, p1);
    }
    now = 1;
    for (int i = 0; i < N; i++) {
        po2[i] = inv2(now);
        now = mul2(now, p2);
    }
    if (1) {
        int n, m;
        cin >> n >> m;
        vector<int> a(n), b(m);
        for (int i = 0; i < n; i++) cin >> a[i];
        for (int i = 0; i < m; i++) cin >> b[i];
        cout << smart_solve(n, m, a, b) << endl;
        return 0;
    }
    while (1) {
        int n = rnd() % 5 + 1, m = rnd() % 5 + 1;
        vector<int> a(n), b(m);
        for (int i = 0; i < n; i++) {
            a[i] = rnd() % 5 + 1;
        }
        for (int i = 0; i < m; i++) {
            b[i] = rnd() % 5 + 1;
        }
        if (solve(n, m, a, b) % 2 == 0) continue;
        if (solve(n, m, a, b) != smart_solve(n, m, a, b)) {
            cout << "ok" << endl;
            cout << n << ' ' << m << endl;
            for (auto to : a) {
                cout << to << ' ';
            }
            cout << endl;
            for (auto to : b) {
                cout << to << ' ';
            }
            cout << endl;
            return 0;
        }
        cout << "ok" << endl;
    }
    return 0;
}
