#include<bits/stdc++.h>

#define int long long
#define pb push_back
#define ld long double

using namespace std;

mt19937 rnd(57);
const int p = 241, MOD = 1178094557, k = 113;

int mul(int a, int b) {
    return (a * b) % MOD;
}

int add(int a, int b) {
    return a + b >= MOD ? a + b - MOD : a + b;
}

int sub(int a, int b) {
    return a - b < 0 ? a - b + MOD : a - b;
}

int binpow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        int g = binpow(a, n / 2);
        return mul(g, g);
    } else {
        return mul(binpow(a, n - 1), a);
    }
}

int inv(int a) {
    return binpow(a, MOD - 2);
}

int dv(int a, int b) {
    return mul(a, inv(b));
}

vector<int> sum(vector<int> a, vector<int> b) {
    vector<int> c(a.size());
    for (int i = 0; i < a.size(); i++) {
        c[i] = a[i] + b[i];
    }
    return c;
}

bool is_palindrom(vector<int> a) {
    int n = a.size();
    for (int i = 0; i < n; i++) {
        if (a[i] != a[n - i - 1]) {
            return 0;
        }
    }
    return 1;
}

int solve(int n, int m, vector<int> a, vector<int> b) {
    for (int k = min(n, m); k >= 1; k--) {
        vector<vector<int>> A, B;
        for (int i = 0; i + k <= n; i++) {
            A.pb(vector<int>{a.begin() + i, a.begin() + i + k});
        }
        for (int i = 0; i + k <= m; i++) {
            B.pb(vector<int>{b.begin() + i, b.begin() + i + k});
        }
        for (auto to1 : A) {
            for (auto to2 : B) {
                if (is_palindrom(sum(to1, to2))) {
                    return k;
                }
            }
        }
    }
    return -1;
}

set<int> sta, stb;

void add(int n, vector<int> a, bool flag, int len) {
    vector<int> pr(n), sf(n);
    if (flag) reverse(a.begin(), a.end());
    int now = 1;
    for (int i = 0; i < n; i++) {
        if (i > 0) {
            pr[i] = pr[i - 1];
        }
        pr[i] = add(pr[i], mul(now, a[i]));
        now = mul(now, p);
    }
    now = 1;
    for (int i = n - 1; i >= 0; i--) {
        if (i + 1 < n) {
            sf[i] = sf[i + 1];
        }
        sf[i] = add(sf[i], mul(now, a[i] + k));
        now = mul(now, p);
    }
    for (int i = 0; i < n; i++) {
        int res = -1;
        if (len % 2 == 1) {
            if (i + len / 2 < n && i - len / 2 >= 0) {
                //int real_res = 0, now = p;
                res = 0;
                res = add(res, dv(sub(sf[i - len / 2], sf[i]), binpow(p, n - i - 1)));
                res = sub(res, dv(sub(pr[i + len / 2], pr[i]), binpow(p, i)));
                /*for (int j = i + 1; j <= i + len / 2; j++) {
                    now = mul(now, p);
                }
                now = p;
                for (int j = i - 1; j >= i - len / 2; j--) {
                    real_res = add(real_res, mul(now, a[j] + k))
                    now = mul(now, p);
                }*/
            }
        } else {
            if (i + len / 2 < n && i - len / 2 + 1 >= 0) {
                res = 0;
                res = add(res, dv(sub(sf[i - len / 2 + 1], sf[i + 1]), binpow(p, n - i - 2)));
                res = sub(res, dv(sub(pr[i + len / 2], pr[i]), binpow(p, i)));
            }
        }
        if (res != -1) {
            if (flag) {
                sta.insert(res);
            } else {
                stb.insert(res);
            }
        }
    }
}

int smart_solve(int n, int m, vector<int> a, vector<int> b) {
    int l = 0, r = min(n, m) + 1;
    while (r - l > 1) {
        int mid = (r + l) / 2;
        if (2 * mid + 1 > min(n, m)) {
            r = mid;
            continue;
        }
        sta.clear();
        stb.clear();
        add(n, a, 1, 2 * mid + 1);
        add(m, b, 0, 2 * mid + 1);
        bool ok = 0;
        for (auto to : sta) {
            if (stb.find(to) != stb.end()) {
                ok = 1;
            }
        }
        if (ok) {
            l = mid;
        } else {
            r = mid;
        }
    }
    int mx = 2 * l + 1;
    l = 0, r = min(n, m) + 1;
    while (r - l > 1) {
        int mid = (r + l) / 2;
        if (2 * mid > min(n, m)) {
            r = mid;
            continue;
        }
        sta.clear();
        stb.clear();
        add(n, a, 1, 2 * mid);
        add(m, b, 0, 2 * mid);
        bool ok = 0;
        for (auto to : sta) {
            if (stb.find(to) != stb.end()) {
                ok = 1;
            }
        }
        if (ok) {
            l = mid;
        } else {
            r = mid;
        }
    }
    mx = max(mx, 2 * l);
    return mx;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    if (1) {
        int n, m;
        cin >> n >> m;
        vector<int> a(n), b(m);
        for (int i = 0; i < n; i++) cin >> a[i];
        for (int i = 0; i < m; i++) cin >> b[i];
        cout << smart_solve(n, m, a, b) << endl;
        return 0;
    }
    while (1) {
        int n = rnd() % 5 + 1, m = rnd() % 5 + 1;
        vector<int> a(n), b(m);
        for (int i = 0; i < n; i++) {
            a[i] = rnd() % 5 + 1;
        }
        for (int i = 0; i < m; i++) {
            b[i] = rnd() % 5 + 1;
        }
        if (solve(n, m, a, b) % 2 == 0) continue;
        if (solve(n, m, a, b) != smart_solve(n, m, a, b)) {
            cout << "ok" << endl;
            cout << n << ' ' << m << endl;
            for (auto to : a) {
                cout << to << ' ';
            }
            cout << endl;
            for (auto to : b) {
                cout << to << ' ';
            }
            cout << endl;
            return 0;
        }
        cout << "ok" << endl;
    }
    return 0;
}
