#include<bits/stdc++.h>

#define pb push_back
#define ld long double
#define ll long long

using namespace std;

mt19937 rnd(51);

const ll INF = 1e18, N = 80000 + 10;
ll t_max[4 * N], t_min[4 * N], add[8 * N], pr[N];

void push(int v) {
    if (add[v] == 0) return;
    add[v * 2] += add[v];
    add[v * 2 + 1] += add[v];
    t_max[v] += add[v];
    t_min[v] += add[v];
    add[v] = 0;
}

void build(int v, int l, int r) {
    if (l == r) {
        t_min[v] = t_max[v] = pr[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m), build(2 * v + 1, m + 1, r);
    t_min[v] = min(t_min[v * 2], t_min[v * 2 + 1]);
    t_max[v] = max(t_max[v * 2], t_max[v * 2 + 1]);
}

void update(int v, int tl, int tr, int l, int r, int val) {
    push(v);
    if (l > r) return;
    if (tl == l && tr == r) {
        add[v] += val;
        push(v);
        return;
    }
    int tm = (tl + tr) / 2;
    update(2 * v, tl, tm, l, min(r, tm), val), update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, val);
    t_max[v] = max(t_max[v * 2], t_max[v * 2 + 1]);
    t_min[v] = min(t_min[v * 2], t_min[v * 2 + 1]);
}

ll get_max(int v, int tl, int tr, int l, int r) {
    push(v);
    if (l > r) return -INF;
    if (tl == l && tr == r) {
        return t_max[v];
    }
    int tm = (tl + tr) / 2;
    return max(get_max(2 * v, tl, tm, l, min(r, tm)), get_max(2 * v + 1, tm + 1, tr, max(l, tm + 1), r));
}

ll get_min(int v, int tl, int tr, int l, int r) {
    push(v);
    if (l > r) return INF;
    if (tl == l && tr == r) {
        return t_min[v];
    }
    int tm = (tl + tr) / 2;
    return min(get_min(2 * v, tl, tm, l, min(r, tm)), get_min(2 * v + 1, tm + 1, tr, max(l, tm + 1), r));
}

int stupid_solve(int n, int k, vector<int> a) {
    ll ans = -INF;
    for (int i = 0; i < n; i++) {
        multiset<int> st;
        for (int j = i; j < n; j++) {
            st.insert(a[j]);
            if (st.size() < k) {
                continue;
            }
            ll res = 0, need = j - i + 1 - k;
            for (auto to : st) {
                if (need == 0) break;
                res += to;
                need--;
            }
            ans = max(ans, res);
        }
    }
    return ans;
}

ll smart_solve(int n, int k, vector<int> a) {
    vector<pair<int, int>> u;
    pr[0] = 0;
    for (int i = 0; i < 4 * N; i++) {
        t_min[i] = t_max[i] = 0;
    }
    for (int i = 0; i < 8 * N; i++) {
        add[i] = 0;
    }
    for (int i = 0; i < n; i++) {
        u.pb({a[i], i});
        if (i > 0) pr[i] = pr[i - 1];
        pr[i] += a[i];
    }
    build(1, 0, n - 1);
    sort(u.rbegin(), u.rend());
    ll ans = -INF;
    if (k == 0) {
        ll mn = 0;
        for (int i = 0; i < n; i++) {
            ans = max(ans, pr[i] - mn);
            mn = min(mn, pr[i]);
        }
        return ans;
    }
    set<int> st;
    for (int i = 0; i < u.size(); i++) {
        st.insert(u[i].second);
        update(1, 0, n - 1, u[i].second, n - 1, -u[i].first);
        if (i + 1 >= k) {
            auto it = st.lower_bound(u[i].second);
            vector<int> arr;
            int need = k;
            while (1) {
                arr.pb(*it);
                need--;
                if (need == 0 || it == st.begin()) break;
                it--;
            }
            it = st.upper_bound(u[i].second);
            reverse(arr.begin(), arr.end());
            need = k;
            while (it != st.end() && need > 0) {
                arr.pb(*it);
                need--;
                it++;
            }
            for (int j = 0; j + k - 1 < arr.size(); j++) {
                ans = max(ans, get_max(1, 0, n - 1, arr[j + k - 1], n - 1) - min(0ll, get_min(1, 0, n - 1, 0, arr[j])));
            }
        }
    }
    return ans;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    if (1) {
        int n, k;
        cin >> n >> k;
        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        cout << smart_solve(n, k, a) << endl;
        return 0;
    }
    while (1) {
        int n = rnd() % 10 + 1, k = rnd() % (n + 1);
        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            a[i] = rnd() % 10 - 5;
        }
        int val = stupid_solve(n, k, a), vall = smart_solve(n, k, a);
        if (val != vall) {
            cout << n << ' ' << k << endl;
            cout << val << ' ' << vall << endl;
            for (auto to : a) {
                cout << to << ' ';
            }
            return 0;
        }
        cout << "ok" << endl;
    }
    return 0;
}
