#include<bits/stdc++.h>

#define pb push_back
#define ld long double
#define ll long long

using namespace std;

mt19937 rnd(51);

const ll INF = 1e18, N = 2e5 + 10;
ll t_min[4 * N], add[8 * N], pr[N], lg[N];
ll po_max[20][N], po_min[20][N];

struct Fenwick {
    vector<ll> t;
    void build(int n) {
        t.resize(n);
    }
    void inc(int i, int d) {
        for (; i < t.size(); i = (i | (i + 1))) {
            t[i] += d;
        }
    }
    ll get(int r) {
        ll ans = 0;
        for (; r >= 0; r = (r & (r + 1)) - 1) {
            ans += t[r];
        }
        return ans;
    }
};

ll get_max(int l, int r) {
    int d = r - l + 1;
    int lq = lg[d];
    return max(po_max[lq][l], po_max[lq][r - (1 << lq) + 1]);
}

ll get_min(int l, int r) {
    int d = r - l + 1;
    int lq = lg[d];
    return max(po_min[lq][l], po_min[lq][r - (1 << lq) + 1]);
}

int stupid_solve(int n, int k, vector<int> a) {
    ll ans = -INF;
    for (int i = 0; i < n; i++) {
        multiset<int> st;
        for (int j = i; j < n; j++) {
            st.insert(a[j]);
            if (st.size() < k) {
                continue;
            }
            ll res = 0, need = j - i + 1 - k;
            for (auto to : st) {
                if (need == 0) break;
                res += to;
                need--;
            }
            ans = max(ans, res);
        }
    }
    return ans;
}

ll smart_solve(int n, int k, vector<int> a) {
    vector<pair<int, int>> u;
    Fenwick t;
    t.build(n);
    pr[0] = 0;
    for (int i = 0; i < 20; i++) {
        if ((1 << i) < N) {
            lg[1 << i] = i;
        }
    }
    for (int i = 1; i < N; i++) {
        lg[i] = max(lg[i], lg[i - 1]);
    }
    for (int i = 0; i < 4 * N; i++) {
        t_min[i] = 0;
    }
    for (int i = 0; i < 8 * N; i++) {
        add[i] = 0;
    }
    for (int i = 0; i < n; i++) {
        u.pb({a[i], i});
        if (i > 0) pr[i] = pr[i - 1];
        pr[i] += a[i];
    }
    for (int i = 0; i < n; i++) {
        po_max[0][i] = po_min[0][i] = pr[i];
    }
    for (int i = 1; i < 20; i++) {
        for (int j = 0; j < n; j++) {
            if (j + (1 << i) <= n) {
                po_max[i][j] = max(po_max[i - 1][j], po_max[i - 1][j + (1 << (i - 1))]);
                po_min[i][j] = min(po_min[i - 1][j], po_min[i - 1][j + (1 << (i - 1))]);
            }
        }
    }
    sort(u.rbegin(), u.rend());
    ll ans = -INF;
    if (k == 0) {
        ll mn = 0;
        for (int i = 0; i < n; i++) {
            ans = max(ans, pr[i] - mn);
            mn = min(mn, pr[i]);
        }
        return ans;
    }
    set<int> st{n, -1};
    for (int i = 0; i < u.size(); i++) {
        st.insert(u[i].second);
        t.inc(u[i].second, -u[i].first);
        if (i + 1 >= k) {
            auto it = st.lower_bound(u[i].second);
            vector<int> arr;
            int need = k + 1;
            while (1) {
                arr.pb(*it);
                need--;
                if (need == 0 || it == st.begin()) break;
                it--;
            }
            it = st.upper_bound(u[i].second);
            reverse(arr.begin(), arr.end());
            need = k + 1;
            while (it != st.end() && need > 0) {
                arr.pb(*it);
                need--;
                it++;
            }
            ll mn = 0, mx = -INF;
            vector<ll> now;
            for (int j = (int)(arr.size()) - 2; j >= 1; j--) {
                mx = max(mx, get_max(arr[j], arr[j + 1] - 1) + t.get(arr[j]));
                now.pb(mx);
            }
            reverse(now.begin(), now.end());
            for (int j = 0; j + k + 1 < arr.size(); j++) {
                mn = min(mn, get_min(arr[j], arr[j + 1] - 1) + t.get(arr[j]));
                ans = max(ans, now[j + k - 1] - mn);
            }
        }
    }
    return ans;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    if (1) {
        int n, k;
        cin >> n >> k;
        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        cout << smart_solve(n, k, a) << endl;
        return 0;
    }
    while (1) {
        int n = rnd() % 10 + 1, k = rnd() % (n + 1);
        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            a[i] = rnd() % 10 - 5;
        }
        int val = stupid_solve(n, k, a), vall = smart_solve(n, k, a);
        if (val != vall) {
            cout << n << ' ' << k << endl;
            cout << val << ' ' << vall << endl;
            for (auto to : a) {
                cout << to << ' ';
            }
            return 0;
        }
        cout << "ok" << endl;
    }
    return 0;
}
